#include <GDIPlus.au3>
Global $sImagefile = @ScriptDir & '\Dandelion.jpg'
Global $aColor[0xFFFFFF]
_GDIPlus_Startup()
Global $hImage = _GDIPlus_BitmapCreateFromFile($sImagefile)
$iTimer = TimerInit()
$iCount = _GetUniqueColors($hImage)
ConsoleWrite('Zeit: ' & TimerDiff($iTimer) & ' ms' & @CR)
ConsoleWrite('Anzahl der Farben: ' & $iCount & @CR)
_GDIPlus_BitmapDispose($hImage)
_GDIPlus_Shutdown()
Exit

Func _GetUniqueColors(ByRef $hImage)
    Local Static $hDll = DllOpen("CountColors.dll")
    Local $iW, $iH, $tBitmapData, $iErr, $aRet
	$iW = _GDIPlus_ImageGetWidth($hImage)
	$iH = _GDIPlus_ImageGetHeight($hImage)
    $tBitmapData = _GDIPlus_BitmapLockBits($hImage, 0, 0, $iW, $iH, $GDIP_ILMREAD, $GDIP_PXF32PARGB)
	$ts = TimerInit()
    $aRet = DllCall($hDll, "int:cdecl", "getColorCount", "ptr", $tBitmapData.Scan0, "int", $iW * $iH)
	ConsoleWrite("DLLCALL-Zeit: " & TimerDiff($ts) & " ms" & @CRLF)
	$iErr = @error
    _GDIPlus_BitmapUnlockBits($hImage, $tBitmapData)
    $tBitmapData = 0
    If Not $iErr Then Return $aret[0]
EndFunc
